<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRequiredPaymentsTypeGuaranteePayment ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfRequiredPaymentsTypeGuaranteePayment extends AbstractStructArrayBase
{
    /**
     * The GuaranteePayment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgGuaranteePayment[]
     */
    public $GuaranteePayment;
    /**
     * Constructor method for ArrayOfRequiredPaymentsTypeGuaranteePayment
     * @uses DgArrayOfRequiredPaymentsTypeGuaranteePayment::setGuaranteePayment()
     * @param \dgsoft\StructType\DgGuaranteePayment[] $guaranteePayment
     */
    public function __construct(array $guaranteePayment = array())
    {
        $this
            ->setGuaranteePayment($guaranteePayment);
    }
    /**
     * Get GuaranteePayment value
     * @return \dgsoft\StructType\DgGuaranteePayment[]|null
     */
    public function getGuaranteePayment()
    {
        return $this->GuaranteePayment;
    }
    /**
     * Set GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgGuaranteePayment[] $guaranteePayment
     * @return \dgsoft\ArrayType\DgArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public function setGuaranteePayment(array $guaranteePayment = array())
    {
        foreach ($guaranteePayment as $arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem instanceof \dgsoft\StructType\DgGuaranteePayment) {
                throw new \InvalidArgumentException(sprintf('The GuaranteePayment property can only contain items of \dgsoft\StructType\DgGuaranteePayment, "%s" given', is_object($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) ? get_class($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem) : gettype($arrayOfRequiredPaymentsTypeGuaranteePaymentGuaranteePaymentItem)), __LINE__);
            }
        }
        $this->GuaranteePayment = $guaranteePayment;
        return $this;
    }
    /**
     * Add item to GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgGuaranteePayment $item
     * @return \dgsoft\ArrayType\DgArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public function addToGuaranteePayment(\dgsoft\StructType\DgGuaranteePayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgGuaranteePayment) {
            throw new \InvalidArgumentException(sprintf('The GuaranteePayment property can only contain items of \dgsoft\StructType\DgGuaranteePayment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GuaranteePayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgGuaranteePayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgGuaranteePayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgGuaranteePayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgGuaranteePayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgGuaranteePayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuaranteePayment
     */
    public function getAttributeName()
    {
        return 'GuaranteePayment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
